#!/usr/bin/python
# -*- coding: utf-8 -*-

import Image, urllib, md5, glob, os.path, stat


#CONF
MUSIC_PATH = '/home/flo/Musique/'
VIDEO_PATH = '/home/flo/Vidéos/'
COVER_FILES = ['cover.png', 'cover.jpg', '.cover.png', '.cover.jpg',
		'Cover.png', 'Cover.jpg', '.Cover.png', '.Cover.jpg',
		'folder.png', 'folder.jpg', '.folder.png', '.folder.jpg',
		'Folder.png', 'Folder.jpg', '.Folder.png', '.Folder.jpg']

DEFAULT_MUSIC_PICTURE = 'music_nocover.png'
DEFAULT_VIDEO_PICTURE = 'video_nocover.png'
DIR_LOGO = 'dir_logo.png'
THUMB_PATH = '/home/flo/Bureau/thumb/'
#THUMB_PATH = os.environ.get('HOME')+'/.thumbnails/normal/'



class thumb(object):
	'''Create a quare thumbnail'''
	def __init__(self, img_uri, logo=''):
		self.img = Image.open(img_uri)
		self.thumb = None

	def create_thumb(self, size=96):
		width = self.img.size[0]
		height = self.img.size[1]
		if width > height:
			left = int((width - height)/2)
			upper = 0
			right = height + left
			lower = height
		else:
			left = 0
			upper = int((height - width)/2)
			right = width
			lower = width + upper
		self.thumb = self.img.crop((left, upper, right, lower))
		self.thumb.thumbnail((size, size), Image.ANTIALIAS)

	def save_thumb(self, thumb_uri, format='PNG'):
		self.thumb.save(thumb_uri, format)


def output_uri(input_path):
	output = 'file://'+urllib.pathname2url(input_path)
	output = output.replace('%27', "'") #Hack for « ' » symbole
	output = output.replace('%2C', ',') #Hack for « , » symbole
	output = output.replace('%2B', '+') #Hack for « + » symbole
	output = output.replace('%28', '(') #Hack for « ( » symbole
	output = output.replace('%29', ')') #Hack for « ) » symbole
	output = md5.md5(output).hexdigest()
	return THUMB_PATH+output+'.png'


def listdir(path):
	dirs = []
	list = glob.glob(path+'/*')
	for i in list: 
		if os.path.isdir(i):
			dirs.extend(listdir(i))
			dirs.append(i)
	return dirs


def do_thumbs(base_path, default_cover='', logo=''):
	#If path is not a directory
	if not os.path.isdir(base_path):
		print 'E: "%s" is not a directory or not exist !' %(base_path)
		return
	#If defaut_cover doesen't exist
	if not os.path.isfile(default_cover):
		default_cover = ''
	#If logo doesen't exist
	if not os.path.isfile(logo):
		logo = ''
	print '\n'
	dir_list = listdir(base_path) #List all the directories in 'base_path'
	progress = 0
	for path in dir_list:
		#Progression informations
		percent = progress*100/(len(dir_list)-1)
		visual = '='*(progress*30/(len(dir_list)-1))
		print '\033[2A  Progression : [%-31s]%3i%%' %(visual+'>', percent)
		print '  > %-70s' %(path[0:69])
		#Find the cover
		cover_path = ''
		for cover in COVER_FILES:
			if os.path.isfile(path+'/'+cover):
				cover_path = path+'/'+cover
				break
		if cover_path == '':
			cover_path = default_cover
		#Define the output path
		output_path = output_uri(path)
		if cover_path != '':
			if os.path.isfile(output_path):
				if os.stat(cover_path)[stat.ST_MTIME] > os.stat(output_path)[stat.ST_MTIME]:
					pic = thumb(cover_path)
					pic.create_thumb(128)
					pic.save_thumb(output_path, 'PNG')
			else:
				pic = thumb(cover_path)
				pic.create_thumb(128)
				pic.save_thumb(output_path, 'PNG')
		progress += 1
	print '\033[1A  > %-70s\n' %('Done.')



print 'Music :'
do_thumbs(MUSIC_PATH, DEFAULT_MUSIC_PICTURE, DIR_LOGO)
print 'Video :'
do_thumbs(VIDEO_PATH, DEFAULT_VIDEO_PICTURE, DIR_LOGO)


